#include <pic.h>
#include <stdio.h>
#include "lcd.h"

struct{
   char tms:1;
	char freq:1;
	char khz:1;
	char mhz:1;
	char ffz:1;

}bits;
#define tms bits.tms
#define freq bits.freq
#define khz bits.khz
#define mhz bits.mhz
#define ffz bits.ffz

unsigned int mSec,Base;
unsigned long Fr;
//unsigned char Per;

void Freq(void);
void DispFreq(unsigned long fr);

static void interrupt
isr(void)         // Here be interrupt function - the name is unimportant.
{
	if(TMR2IF==1){
	if(freq){
	--Base;
	if(Base==0)
	  freq=0;	
			}
	TMR2IF=0;}

	if(TMR1IF==1&&TMR1IE==1)
	{++Fr;
	 TMR1IF=0;}

   	if(T0IF){             // timer interrupt      
      TMR0+=131;         //8MHz/4/16/125=1kHz T=1msek
      if(tms){
      --mSec;
      if(mSec==0)
      tms=0;
      }
      T0IF = 0;         // clear the interrupt flag
   }
}
void main(void){
char tab[10],j;


	OPTION=0b00000011;//ustawienie TMR0
	T2CON=0b00000111;//ustawienie TMR2
	TMR1CS=1;
	TMR1GE=0;
	T1SYNC=1;
	PR2=125;
	T0IE = 1;		// odblokowanie przerwania od przepelnienia TMR0
	TMR2IE=1;
	PEIE=1;
	GIE = 1;		// Global interrupt enable
	TRISD=0;
	TRISC7=0;
	InicLcd();
	PosLcd(1,1);
	DispLcd("f= ");
	while(1){
	
	Freq();
	delay_ms(500);
	}
}
void DispFreq(unsigned long fr){
char tab[10],i,j,p;
	khz=mhz=0;
	j=sprintf(tab,"%lu",fr);
	PosLcd(4,1);
	DispLcd("              ");
	PosLcd(14,1);
	if(fr<1000)
	DispLcd("Hz ");
	if(fr>=1000&&fr<1000000)
	{DispLcd("kHz");
	 khz=1;}
	if(fr>=1000000)
	{DispLcd("MHz");
	 mhz=1;}
	p=12;
	for(i=0;i<j;i++){
	if(khz==1&&i==3){
	PosLcd(p-i,1);
	WriteRd('.');
	--p;
	}
	if(mhz==1&&i==6){
	PosLcd(p-i,1);
	WriteRd('.');
	--p;
	}
	PosLcd(p-i,1);
	WriteRd(tab[j-i-1]);
	}
} 
void delay_ms(unsigned int msek){
	mSec=msek;
	TMR0|=131;
	tms=1;
	while(tms);
}

void Freq(void){
	
	Base=1000;
	freq=1;
	Fr=0;
	TMR1IE=0;
	TMR1L=0;
	TMR1H=0;
	TMR1IF=0;
	TMR1IE=1;
	TMR1ON=1;
	TMR2ON=1;
	TMR2=0;
	RC7=1;
	while(freq);
	RC7=0;
	TMR1ON=0;
	TMR1IE=0;
	TMR2ON=0;
	Fr=Fr<<8;
	Fr=Fr|TMR1H;
	Fr=Fr<<8;
	Fr=Fr|TMR1L;
	DispFreq(Fr);
		
}



