#include <pic.h>
#include "i2c.h"

void OpenI2C(void){
	TRISC=TRISC&(~0b00011000);
	RC3=0;
	RC4=0;
	SDA=1;
	SCL=1;
}
void i2c_start(void){
	SDA=1; SCL=1;
	SDA=0;
	asm ("nop"); asm("nop");
	SCL=0;
	asm ("nop"); asm("nop");
}
void i2c_stop(void){
	SCL=1;
	while(!PSCL);//czekaj na zakonczenie wait state
	SDA=1;
}
char i2c_write (unsigned char data){
char i;
	for (i=0;i<8;i++)
	{if((data&0x80)==0x80)
	 SDA=1;
	 else
	 SDA=0;
	 asm ("nop"); asm("nop");
	 SCL=1;
	 while(!PSCL);//czekaj na SCL=1
	 asm ("nop"); asm("nop");
	 SCL=0;
	 data=data<<1;
	} 
	asm ("nop"); asm("nop");
	SDA=1;
	SCL=1;
	while(!PSCL);//czekaj na SCL=1
	if(PSDA==1)
	i=1;
	else
	i=0;
	asm ("nop"); asm("nop");
	SCL=0;
	return(i);
}

unsigned char i2c_read(unsigned char ack){
unsigned char data,i;
	SDA=1;
	data=0;
	ack=ack&1;
	for(i=0;i<8;i++){
	data=data<<1;
	SCL=1;
	while(!PSCL);//czekaj na SCL=1
	if(PSDA==1)
	data=data|1;
	else
	data=data&0xfe;
	asm ("nop"); asm("nop");
	SCL=0;
	asm ("nop"); asm("nop");
	}
	if(ack==1)
	SDA=1;
	else
	SDA=0;
	SCL=1;
	while(!PSCL);//czekaj na SCL=1
	asm ("nop"); asm("nop");
	SCL=0;
	asm ("nop"); asm("nop");
	return(data);
		
}

